/*
 *  MICO --- a free CORBA implementation
 *
 *  MicoCCM written by Frank Pilhofer, sponsored by Alcatel
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/CCMContainer.h>
#include <hello.h>

#ifndef __HELLO__CCM__H__
#define __HELLO__CCM__H__

namespace MICO_CCM_impls {

  /*
   * Glue class for component HelloWorld
   */

  class HelloWorld_impl :
      virtual public POA_HelloWorld,
      virtual public PortableServer::RefCountServantBase
  {
      friend class HelloWorld_Context_impl;

    private:
      CCM_HelloWorld * _instance;
      CCM_HelloWorld_Context * _context;
      MICO::CCM::SessionContainer * _container;

    public:
      HelloWorld_impl (CCM_HelloWorld *, 
      MICO::CCM::SessionContainer *);
      ~HelloWorld_impl ();

      /*
       * Component Attributes
       */

      char* message ();
      void message (const char* _value);

      /*
       * Supported Interfaces
       */

      // ::Hello

      void sayHello();

      // none

      /*
       * Equivalent IDL methods
       */

      // no receptacles

      // no publishers

      // no emitters

      // no consumers

      /*
       * Inherited Navigation interface
       */

      CORBA::Object_ptr provide_facet (const char *);
      Components::FacetDescriptions * get_all_facets ();
      Components::FacetDescriptions * get_named_facets (const Components::NameList &);
      CORBA::Boolean same_component (CORBA::Object_ptr ref);

      /*
       * Inherited Receptacles interface
       */

      Components::Cookie * connect (const char *, CORBA::Object_ptr);
      void disconnect (const char * name, Components::Cookie *);
      Components::ConnectionDescriptions * get_connections (const char *);
      Components::ReceptacleDescriptions * get_all_receptacles ();
      Components::ReceptacleDescriptions * get_named_receptacles (const Components::NameList &);

      /*
       * Inherited Events interface
       */

      Components::EventConsumerBase_ptr get_consumer (const char *);
      Components::Cookie * subscribe (const char *, Components::EventConsumerBase_ptr);
      void unsubscribe (const char * name, Components::Cookie *);
      void connect_consumer (const char *, Components::EventConsumerBase_ptr);
      Components::EventConsumerBase_ptr disconnect_consumer (const char *);
      Components::ConsumerDescriptions * get_all_consumers ();
      Components::ConsumerDescriptions * get_named_consumers (const Components::NameList &);
      Components::EmitterDescriptions * get_all_emitters ();
      Components::EmitterDescriptions * get_named_emitters (const Components::NameList &);
      Components::PublisherDescriptions * get_all_publishers ();
      Components::PublisherDescriptions * get_named_publishers (const Components::NameList &);

      /*
       * Inherited CCMObject interface
       */

      CORBA::Object_ptr get_component_def ();
      Components::CCMHome_ptr get_ccm_home ();
      void configuration_complete ();
      void remove ();
      Components::ComponentPortDescription * get_all_ports ();

      /*
       * Overload default implementation
       */

      CORBA::Object_ptr _get_component ();
  };


  /*
   * Context class for component HelloWorld
   */

  class HelloWorld_Context_impl :
      virtual public CCM_HelloWorld_Context
  {
    private:
      HelloWorld_impl * _glue;
      MICO::CCM::SessionContainer * _container;

    public:
      HelloWorld_Context_impl (HelloWorld_impl * _g, MICO::CCM::SessionContainer * _c);
      ~HelloWorld_Context_impl ();

      Components::CCMHome_ptr get_CCM_home ();
      CORBA::Object_ptr get_CCM_object ();
  };


  /*
   * Glue class for home HelloHome
   */

  class HelloHome_impl :
      virtual public POA_HelloHome,
      virtual public PortableServer::RefCountServantBase
  {
    private:
      CCM_HelloHome * _instance;
      MICO::CCM::SessionContainer * _container;

    public:
      HelloHome_impl (CCM_HelloHome *, MICO::CCM::SessionContainer *);
      ~HelloHome_impl ();

      /*
       * Implicit operations
       */

      HelloWorld_ptr create ();

      /*
       * Explicit operations
       */

      // no factories

      // no finders

      // attributes

      char* initial_message ();
      void initial_message (const char* _value);

      // no operations

      /*
       * Inherited CCMHome interface
       */

      CORBA::Object_ptr get_component_def ();
      CORBA::Object_ptr get_home_def ();
      void remove_component (Components::CCMObject_ptr comp);

      /*
       * Inherited KeylessCCMHome interface
       */

      Components::CCMObject_ptr create_component ();

  };


  // end of namespace MICO_CCM_impls
}

#endif

